
/*************************************************
****     VEGA - HyperChem loader & saver      ****
**** Copyright 1996-2001, Alessandro Pedretti ****
*************************************************/


#include <stdio.h>
#include <string.h>

#include "globdef.h"
#include "globvar.h"


/**** HIN Loader ****/

ATOMO *HINLoad(FILE *IN, RECORD *Lin, VG_ULONG *TotAtomi)
{
  ATOMO             *InizAtm;
  char		    ResSeqStr[20];
  VG_QCHAR          ResName, ResSeq;

  register ATOMO    *Atm = NULL;

  while(fgets(Lin -> Line, LINELEN, IN)) {

    /**** atom rrecord ****/

    if (!strncmp(Lin -> Line, "atom", 4)) {
      if ((Atm = AllocAtm(&InizAtm, TotAtomi))) {
        sscanf(Lin -> Line, "%*s %*s %4s %2s %4s %*s %f %f %f %f",
               Atm -> Name.C, Atm -> Elem.C, Atm -> Pot.C, &Atm -> Charge,
               &Atm -> x, &Atm -> y, &Atm -> z);
        if (*Atm -> Name.C == '-') {
          Atm -> Name.L    = 0;
          Atm -> Name.C[0] = Atm -> Elem.C[0];
          Atm -> Name.C[1] = Atm -> Elem.C[1];
        }
        if (ResName.L) {
          Atm -> ResName.L = ResName.L;
          Atm -> ResSeq.L  = ResSeq.L;
        }
      } else break;
    }

    /**** endmol record ****/

    if ((!strncmp(Lin -> Line, "endmol", 6)) && (Atm))
      Atm -> Flags = 2;

    /**** endres record ****/

    if (!strncmp(Lin -> Line, "endres", 6))
      ResName.L = 0;

    /**** res record ****/

    if (!strncmp(Lin -> Line, "res", 3)) {
      ResName.L = 0;
      sscanf(Lin -> Line, "%*s %18s %48s", ResSeqStr, ResName.C);
      Str2Qchar(&ResSeq, ResSeqStr);
    }
  } /* End of while */

  if (Atm) {
    Atm -> Flags = 2;
    LastAtm      = Atm;
  }

  return InizAtm;
}


