
/*************************************************
****         VEGA - MDL Mol loader            ****
**** Copyright 1996-2002, Alessandro Pedretti ****
*************************************************/


#include <stdio.h>

#include "globdef.h"
#include "globvar.h"


/**** MDL Loader ****/

ATOMO *MdlMolLoad(FILE *IN, RECORD *Lin, VG_ULONG *TotAtomi)
{
  register ATOMO        *Atm     = NULL;
  ATOMO                 *InizAtm = NULL;
  VG_ULONG              k        = 0;

  sscanf(Lin -> Line, "%3d", &k);
  while((k--) && (fgets(Lin -> Line, LINELEN, IN))) {
    if ((Atm = AllocAtm(&InizAtm, TotAtomi))) {
      sscanf(Lin -> Line, "%9f %9f %9f %3s",
             &Atm -> x, &Atm -> y, &Atm -> z, Atm -> Name.C);
      Atm -> Elem.C[0] = Atm -> Name.C[0];
      Atm -> Elem.C[1] = Atm -> Name.C[1];
    } else break;
  } /* End of while */

  if (Atm) {
    Atm -> Flags = 2;
    LastAtm      = Atm;
  }

  return InizAtm;
}